=== debian/changelog ===
insighttoolkit4 (4.1.0-1) experimental; urgency=low

  * New upstream release.
    patches/gzgetc.patch: Remove.  Applied upstream.

 -- Steve M. Robbins <smr@debian.org>  Sat, 03 Mar 2012 20:31:43 -0600

insighttoolkit4 (4.0.0-1) experimental; urgency=low

  * New upstream, major release.  Removed all patches.
  
  * rules: Reworked CMAKE_FLAGS from scratch.  Update for new install
    practice: libs in /usr/lib, includes in /usr/include/ITK-4.0.
  
  * patches/gzgetc.patch: New.  Fix to build with zlib where gzgetc is a
    macro.

 -- Steve M. Robbins <smr@debian.org>  Thu, 26 Jan 2012 20:42:39 -0600

insighttoolkit (3.20.1-2) unstable; urgency=low

  [ Mathieu Malaterre ]

  * rules: Use system installed VXL
  * control.in: Add myself as uploader.  

  [ Steve M. Robbins ]
  
  * control.in: -dev package depends on libgdcm2-dev.  Closes: #587589

 -- Steve M. Robbins <smr@debian.org>  Sat, 21 Jan 2012 12:23:58 -0600

insighttoolkit (3.20.1-1) unstable; urgency=low

  * New upstream.
    - patches/metaio-test-vtk_source.patch:
    - patches/ptrdiff.patch: Remove.  Applied upstream.

 -- Steve M. Robbins <smr@debian.org>  Thu, 27 Oct 2011 22:24:59 -0500

insighttoolkit (3.20.0-17) unstable; urgency=low

  * rules: Make example files permission fix conditional on installing
    $(pkg_examples).

 -- Steve M. Robbins <smr@debian.org>  Sat, 17 Sep 2011 22:21:18 -0500

insighttoolkit (3.20.0-16) unstable; urgency=low

  * Remove language wrappings.  New source packages, one per wrapped
    language will be introduced to build the wrappings.  
  * Build in Release mode for full -O3 optimization.  
  * Build in parallel.
  * Use debhelper instead of cdbs.

 -- Steve M. Robbins <smr@debian.org>  Sat, 17 Sep 2011 12:31:22 -0500

insighttoolkit (3.20.0-15) unstable; urgency=low

  * control.in: Restore build-dependency on libtiff4-dev (fails to
  build with libtiff5).

 -- Steve M. Robbins <smr@debian.org>  Sun, 11 Sep 2011 18:02:04 -0500

insighttoolkit (3.20.0-14) experimental; urgency=low

  * control.in:
  * rules: Follow upstream to install python wrapping into
    /usr/lib/InsightToolkit, with WrapITK.pth in dist-packages.  Switch to
    dh_python2.

  * rules: Change build type from RELEASE to RelWithDebInfo.  This reduces
    optimization from -O3 to -O2 which should help with excessive memory
    usage during build (see #640667).

 -- Steve M. Robbins <smr@debian.org>  Sat, 10 Sep 2011 14:45:13 -0500

insighttoolkit (3.20.0-13) unstable; urgency=low

  * Remove absolute paths to required libraries from
    /usr/lib/InsightToolkit/ITKLibraryDepends.cmake after building,
    closes: #635300.  Due to the multiarch transition, the original
    behavior frequently causes reverse build-deps to FTBFS.  This change
    should probably be reverted once all required libraries are
    multiarched.

 -- Michael Schutte <michi@debian.org>  Tue, 16 Aug 2011 20:52:58 +0200

insighttoolkit (3.20.0-12) unstable; urgency=low

  * patches/itkImageToImageFilterC.patch: Remove.
  * patches/wrap-iifilter-split.patch: New; replaces above patch.  Split
    itkImageToImageFilterB into 3 files, introducing FilterC and FilterD.

 -- Steve M. Robbins <smr@debian.org>  Fri, 12 Aug 2011 20:08:27 -0500

insighttoolkit (3.20.0-11) unstable; urgency=low

  * control: Build-depend on newer gccxml that removes "inline namespace"
    from c++config.h.  Closes: #632582.

 -- Steve M. Robbins <smr@debian.org>  Sun, 24 Jul 2011 00:16:22 -0500

insighttoolkit (3.20.0-10) unstable; urgency=low

  * patches/ptrdiff.patch.  New.  Include <stddef.h> to ensure ptrdiff_t
    is defined.  Closes: #625077, #624941, #625090.
  
  * rules: Enable optimized registration methods and transform IO
    factories.  Closes: #614519.
  
  * patches/tcl-install.patch: Set WRAP_ITK_PACKAGE_DIR to /usr/lib.
    Closes: #618736.
  
  * control: Build-depend on newer gccxml.

 -- Steve M. Robbins <smr@debian.org>  Fri, 06 May 2011 01:31:04 -0500

insighttoolkit (3.20.0-9) unstable; urgency=low

  * control: Build-depend on newer gccxml and cableswig.

 -- Steve M. Robbins <smr@debian.org>  Sun, 06 Mar 2011 15:11:09 -0600

insighttoolkit (3.20.0-8) unstable; urgency=low

  * rules: Remove parallel build.

 -- Steve M. Robbins <smr@debian.org>  Wed, 16 Feb 2011 00:44:55 -0600

insighttoolkit (3.20.0-7) unstable; urgency=low

  * patches/itkImageToImageFilterC.patch: New.  Split the
    ImageToImageFilter into smaller modules to avoid compiler table
    overflow (build failure).
  
  * rules: Try parallel build again.
  
 -- Steve M. Robbins <smr@debian.org>  Sat, 12 Feb 2011 20:04:44 -0600

insighttoolkit (3.20.0-6) unstable; urgency=low

  [Paul Novotny]
  * control:
  * rules:
  * patches/wrapitk-externalprojects.patch: New.  Add two External
    Projects to the WrapITK build. PyBuffer provides easy interoperability
    with numpy. ItkVtkGlue makes it easy to convert from and to VTK.
  
  * rules: Turn off wrapping 4D images, fix wrap setting misspellings.
  
  * patches/add-registration-optimizers.patch: New.  Add a couple new
    registration optimizers, including LBFGSBOptimizer used for B-spline
    3D registration.  Add a few array types to use the optimizers
    correctly.
  
  [Steve Robbins]
  * control: Add build-deps on libvtk5-dev, python-vtk for ItkVtkGlue.
    Remove unnecessary build-deps libjpeg62-dev, libtiff4-dev,
    libfreetype6-dev, libopenjpeg-dev, graphviz, libxext-dev, libxss-dev,
    libxft-dev, libpoppler-dev, libssl-dev.  Closes: #608394.

 -- Steve M. Robbins <smr@debian.org>  Mon, 07 Feb 2011 01:35:06 -0600

insighttoolkit (3.20.0-5) experimental; urgency=low

  * patches/wrapitk.patch: New.  Use ITK_LIBRARY_PROPERTIES to properly
    version libSwigRuntime{Python,Java,Tcl} and the Tcl shared libs (which
    are installed in /usr/lib).

  * rules: Install libSwigJava into /usr/lib.

 -- Steve M. Robbins <smr@debian.org>  Wed, 22 Dec 2010 23:32:20 -0600

insighttoolkit (3.20.0-4) experimental; urgency=low


